"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.clickOutside = void 0;
/** With specified extra nodes, the event will only fire
 * 	if the click was outside all of the nodes. */
var clickOutside = function (node, extraNodes) {
    var handleClick = function (event) {
        var outsideExtraNodes = true;
        if (extraNodes === null || extraNodes === void 0 ? void 0 : extraNodes.length) {
            extraNodes.map(function (extNode) {
                if (extNode && (extNode === null || extNode === void 0 ? void 0 : extNode.contains(event.target))) {
                    outsideExtraNodes = false;
                }
            });
        }
        if (!outsideExtraNodes)
            return;
        if (!(node === null || node === void 0 ? void 0 : node.contains(event.target))) {
            node.dispatchEvent(new CustomEvent('clickOutside'));
        }
    };
    document.addEventListener('click', handleClick, true);
    return {
        destroy: function () {
            document.removeEventListener('click', handleClick, true);
        },
    };
};
exports.clickOutside = clickOutside;
exports.default = clickOutside;
